package com.njcn.csharmonic.api.fallback;

import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.csharmonic.api.CsHarmonicPlanLineFeignClient;
import com.njcn.csharmonic.param.CsHarmonicPlanLineParam;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author xy
 */
@Slf4j
@Component
public class CsHarmonicPlanLineFeignClientFallbackFactory implements FallbackFactory<CsHarmonicPlanLineFeignClient> {
    @Override
    public CsHarmonicPlanLineFeignClient create(Throwable cause) {
        //判断抛出异常是否为解码器抛出的业务异常
        Enum<?> exceptionEnum = CommonResponseEnum.SERVICE_FALLBACK;
        if (cause.getCause() instanceof BusinessException) {
            BusinessException businessException = (BusinessException) cause.getCause();
        }
        Enum<?> finalExceptionEnum = exceptionEnum;
        return new CsHarmonicPlanLineFeignClient() {
            @Override
            public HttpResult<String> getPlanIdByLineId(String lineId) {
                log.error("{}异常，降级处理，异常为：{}","根据监测点ID查询方案ID异常",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public HttpResult<Boolean> savePlanLines(CsHarmonicPlanLineParam param) {
                log.error("{}异常，降级处理，异常为：{}","新增方案与监测点关联异常",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public HttpResult<Boolean> deleteByLineIds(List<String> lineIds) {
                log.error("{}异常，降级处理，异常为：{}","根据监测点ID集合删除关联异常",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }
        };
    }
}
